您的位置:首页 > 其它

Travelling(spfa+状态压缩dp)

2015-09-28 08:22 337 查看

题目连接:http://acm.hdu.edu.cn/showproblem.php?pid=3001

Travelling

Time Limit: 6000/3000 MS (Java/Others) Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 5295 Accepted Submission(s): 1718


[align=left]Problem Description[/align]
After coding so many days,Mr Acmer wants to have a good rest.So travelling is the best choice!He has decided to visit n cities(he insists on seeing all the cities!And he does not mind which city being his start station because superman can bring him to any city at first but only once.), and of course there are m roads here,following a fee as usual.But Mr Acmer gets bored so easily that he doesn't want to visit a city more than twice!And he is so mean that he wants to minimize the total fee!He is lazy you see.So he turns to you for help.

[align=left]Input[/align]
There are several test cases,the first line is two intergers n(1<=n<=10) and m,which means he needs to visit n cities and there are m roads he can choose,then m lines follow,each line will include three intergers a,b and c(1<=a,b<=n),means there is a road between a and b and the cost is of course c.Input to the End Of File.

[align=left]Output[/align]
Output the minimum fee that he should pay,or -1 if he can't find such a route.

[align=left]Sample Input[/align]

2 1
1 2 100
3 2
1 2 40
2 3 50
3 3
1 2 3
1 3 4
2 3 10

[align=left]Sample Output[/align]

100
90
7

[align=left]Source[/align]
2009 Multi-University Training Contest 11 - Host by HRBEU

题意:一个地图可以从任意一个地点出发,到达遍历所有的点,每个点最多可以被访问2次,问这样遍历所有的点的最小边权和是多少。

题解:观察这个题的数据范围是10,而且要求每个点有3个状态:未被访问,被访问1次,被访问2次。是一个类似于汉密顿的问题(汉密顿问题是每个点经过且只经过一次)

考虑用状态压缩dp来写,但是一般的状态压缩是用0,1表示访问和未访问两个状态,所以用一个二进制数来表示这个地图的某个状态。而这个题是一个点有三个状态,未被访问,被访问一次,被访问2次。所以自然的想到用一个三进制数来表示,集合的运算完全类比于二进制的情况。

参见/article/5243506.html 的spfa思路

代码:

#include<cstdio>
#include<iostream>
#include<algorithm>
#include<cstring>
#include<cmath>
#include<queue>
using namespace std;
#define N 11
#define INF 0x7f7f7f7f//注意memset里的0x7f的值在int中是0x7f7f7f7f

int mp

;
bool vis[177777]
;
int dp[177777]
;
queue<pair<int,int> > q;
bool ch(int s, int n)
{
for(int i = 0; i < n; i++) {
if(s%3 == 0) return false;
s /= 3;
}
return true;
}//检验最后的这个状态中是否是每个点都访问过
int main()
{
int n , m ;
while(~scanf("%d%d",&n,&m))
{
memset(vis,0,sizeof(vis));
memset(dp,0x7f,sizeof(dp));
memset(mp,0x7f,sizeof(mp));
for(int i =0 ;i < n ;i++)
mp[i][i] = 0;
dp[0][0] = 0;
vis[0][0] = 1;
q.push(make_pair(0,0));
for(int i = 0; i < n; i++){
dp[(int)(pow(3, i))][i] = 0;
q.push(make_pair(pow(3, i), i));
}
int u, v , d;
for(int i =0 ; i < m ; i++)
{
scanf("%d%d%d",&u,&v,&d);
u--,v--;
mp[u][v] = mp[v][u] = min(mp[u][v],d);
}
int tm = pow(3,n)-1;
while(!q.empty())
{
int s = q.front().first;
int u = q.front().second;
q.pop();
vis[s][u] = 0;
int cur = s, ss;
for(int i = 0 ;i < n ; i++)
{
int bt = cur % 3;
cur /= 3;//因为要考虑到没有用的数,及这个位置已经是2了就要在这个位置的下一位考虑了
if(bt < 2) {
ss = s + pow(3, i);
if(dp[ss][i]>dp[s][u]+mp[i][u]){
dp[ss][i] = dp[s][u] + mp[i][u];
if(vis[ss][i] == 0){
vis[ss][i] = 1;
q.push(make_pair(ss,i));
}
}
}
}
}
//for(int i = 0; i < pow(3, n); i++)
//    for(int j = 0; j < n; j++)
//        printf("%d %d : %d\n", i, j, dp[i][j]);
int ans = INF;
for(int s = 0; s <= tm; s++)
for(int i = 0 ;i < n ;i++)
if(ch(s, n)) ans = min(ans,dp[s][i]);
if(ans==INF) printf("-1\n");
else printf("%d\n",ans);
}
return 0;
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: